
function Statistic(numbers) {
	this.nums = clone(numbers);
	if(typeof this.__construct === "undefined") { throw "can't call " + arguments.callee.name + "(), use new " + arguments.callee.name + "()!" };
	/*if(__construct === undefined) { throw "construct me, bitch!"; }*/
	this.__construct();
}

Statistic.prototype = {
	__construct : function() {
		this.Recalc();
	},
	
	Recalc : function() {
		var cnt = this.nums.length;
		if(cnt == 0) { return false; }
		
		//Werte sortieren
		this.nums.sort(function(a, b) { return a - b; });
		
		this.min = this.nums[0];
		this.max = this.nums[cnt - 1];
		
		//Quartile berechnen
		this.quartil = [];
		for(var i = 0; i < 3; i++) {
			var xpos = (cnt - 1) * (i+1) / 4;
			var pos = Math.floor(xpos);
			this.quartil[i] = this.nums[pos];
			if(xpos % 1 != 0) {
				this.quartil[i] += this.nums[pos+1];
				this.quartil[i] /= 2;
			}
		}
		this.median = this.quartil[1];
		this.iqr = this.quartil[2] - this.quartil[0];
		
		//Versteh ich zwar nicht, funktioniert aber
		var sqsum = 0;
		this.mean = this.nums[0];
		for (var i = 1; i < cnt; i++) {
			var x = this.nums[i];
			var delta = x - this.mean;
			var sweep = i + 1.0;
			this.mean += delta / sweep;
			sqsum += delta * delta * (i / sweep);
			
			//this.histo[x] = (this.histo[x] === undefined) ? 1 : (this.histo[x] + 1);
		}
		
		this.sum = this.mean * cnt; //Summe aller Werte
		this.variance = sqsum / cnt; //Varianz
		this.sdev = Math.sqrt(this.variance); //?
		
		//Histogramm
		this.histostepsize = 1; //fr andere Werte nicht stabil
		this.histo = {};
		for(var i = this.min; i < this.max; i += this.histostepsize) {
			this.histo[i] = 0;
		}
		for(var i = 0; i < cnt; i++) {
			var x = this.nums[i];
			var thisstep = x / this.histostepsize;
			thisstep = Math.floor(thisstep) * this.histostepsize
			var nextstep = thisstep + this.histostepsize;
			
			var delta = x - thisstep;
			
			if(this.histo[thisstep] === undefined) { this.histo[thisstep] = 0; }
			this.histo[thisstep] += 1 - delta;
			if(delta > 0) {
				if(this.histo[nextstep] === undefined) { this.histo[nextstep] = 0; }
				this.histo[nextstep] += delta;
			}
		}
	}
}

function hist2arr(hist, arr) {
	if(arr === undefined) { arr = []; }
	for(var i in hist) {
		var val = parseInt(i);
		for(var j = 0; j < hist[i]; j++) {
			arr[arr.length] = val;
		}
	}
	return arr;
}