﻿function getCSSRule(ruleName, deleteFlag) {
	ruleName = ruleName.toLowerCase();
	var lastRule = null; var lastRuleCnt = 0;
	if(document.styleSheets) {
		for(var i=0; i<document.styleSheets.length; i++) {
			var styleSheet=document.styleSheets[i];
			var ii=0;
			var cssRule=false;
			do {
				if (styleSheet.cssRules) {
					cssRule = styleSheet.cssRules[ii];
				} else {
					cssRule = styleSheet.rules[ii];
				}
				if(cssRule) {
					if(cssRule.selectorText.toLowerCase()==ruleName) {
						if(deleteFlag===true) {
							if(styleSheet.cssRules) {
								styleSheet.deleteRule(ii);
							} else {
								styleSheet.removeRule(ii);
							}
							return true;
						} else {
							return cssRule;
						}
					}
				}
				ii++;
				if(lastRule === cssRule) { lastRuleCnt++; } else { lastRuleCnt = 0; }
				if(lastRuleCnt > 10) { return false; }
				lastRule = cssRule;
			} while (cssRule !== false);
		}
	}
	return false;
}

function killCSSRule(ruleName) {
	return getCSSRule(ruleName, true);
}

function addCSSRule(ruleName) {
	if(document.styleSheets) {
		if(!getCSSRule(ruleName)) {
			if(document.styleSheets[0].addRule) {
				document.styleSheets[0].addRule(ruleName, null,0);
			} else {
				document.styleSheets[0].insertRule(ruleName+' { }', 0);
			}
		}
	}
	return getCSSRule(ruleName);
}

function isElemVisible(obj) {
	if(obj == document) { return true; }
	
	if(!obj) { return false; }
	if(!obj.parentNode) { return false; }
	if(obj.style) {
		if(obj.style.display == 'none') { return false; }
		if(obj.style.visibility == 'hidden') { return false; }
	}

	if(window.getComputedStyle) {
		var style = window.getComputedStyle(obj, "");
		if(style.display == 'none') { return false; }
		if(style.visibility == 'hidden') { return false; }
	}
	
	style = obj.currentStyle;
	if(style) {
		if(style.display == 'none') { return false; }
		if(style.visibility == 'hidden') { return false; }
	}
	
	return isElemVisible(obj.parentNode);
}