﻿/**
 * @author: Christof Rueß, http://hobbyelektronik.org
 * @license: http://creativecommons.org/licenses/by-nc-sa/3.0/
 * Feel free to share and remix this 
 * but:
 * - leave this comment in the code
 * - don't use this code for commercial purposes
 * - when you alter this code: c'mon, share it like I did!
 *
 * see: http://www.hobbyelektronik.org/wiki/index.php?title=Commercial_Use
 */

function Events() {}
Events = {
	Add : function (obj, evt, fn) {
		if(obj.addEventListener) { obj.addEventListener(evt, fn, false); }
		else if(obj.attachEvent) { obj.attachEvent('on' + evt, fn); }
	},

	Remove : function (obj, evt, fn) {
		if(obj.removeEventListener) { obj.removeEventListener(evt, fn, false); }
		else if(obj.detachEvent) { obj.detachEvent('on' + evt, fn); }
	}
};