function Timer(func, interval) {
	this.interval = interval;
	this.tmr = null;
	this.func = func;
	this.__construct();
}

Timer.prototype = {
	__construct : function() {
		this.Enable()
	},
	
	Enable : function() {
		if(typeof this.func == "function" && this.interval > 0 && this.tmr == null) {
			var oThis = this;
			this.tmr = window.setInterval(function() { oThis.func(); }, this.interval);
		}
	},
	
	Disable : function() {
		if(this.tmr !== null) {
			window.clearInterval(this.tmr);
			this.tmr = null;
		}
	},
	
	SetInterval : function(interval) {
		if(interval == this.interval || interval <= 0) { return; }
		this.interval = interval;
		if(this.tmr !== null) {
			window.clearInterval(this.tmr);
			this.tmr = null;
			this.Enable();
		}
	}
}
